#!/usr/local/bin/perl

# CGI mod_auth_tkt example login script

use lib '/path/to/TktUtil';
use TktUtil qw(encrypt get_auth_cookie);
use CGI;
use URI::Escape;
use strict;

# Change at least the next two lines!
$TktUtil::SECRET_CONFIG_FILE = '/opt/web/conf/mod_auth_tkt.conf';
my $AUTH_DOMAIN = '.foo.com';
my $AUTH_COOKIE_NAME = 'perl_session';
my $BACK_COOKIE_NAME = 'back';

my $q = new CGI;

my $ip_addr = $ENV{REMOTE_ADDR};
my $username = lc($q->param('username'));
my $password = $q->param('password');

# NB: validate user here - this example is a noop
my @errors;
my $ticket;
if ($username) {
  # Add anything you like inside the user data
  my $user_data = encrypt($password) . ':' . time() . ':' . $ip_addr;
  # If using TKTAuthIgnoreIP option simply don't pass ip_addr here
  $ticket = get_auth_cookie(uid => $username, ip_addr => $ip_addr,
    data => $user_data, errors => \@errors,
    cookie => 1, name => $AUTH_COOKIE_NAME, domain => $AUTH_DOMAIN
  );

  # Set ticket and redirect
  if ($ticket) {
    # Redirect to a back cookie or back parameter address, if found
    my $back = $q->cookie(-name => $BACK_COOKIE_NAME);
    $back = "http://$back" if $back;
    $back ||= $q->param($BACK_COOKIE_NAME);
    if ($back) {
        print $q->header(-cookie => $ticket, -location => uri_unescape($back));
    }
    else {
        print $q->header(-cookie => $ticket);
    }
  }
  else {
      print $q->header();
  }
}

# If here, probably some kind of error
print <<EOD;
<html>
<body bgcolor="white">
<div align="center">
EOD

if (@errors) {
  print qq(<p class="error">\n);
  print join(qq(</p>\n<p class="error">), @errors), "</p>\n";
}
elsif ($ticket) {
  print qq(<p>Logged in.</p>\n);
}
else {
  print qq(<p class="error">Error: invalid username or password.</p>\n);
}

print <<EOD;
</div>
</body>
</html>
EOD
